# **********************************************************************
# Copyright 2014 VMware, Inc.  All rights reserved. VMware Confidential.
# **********************************************************************
# $Id$
# $DateTime$
# $Change$
# $Author$
# **********************************************************************
import nsx_logging
import os
import json
import uuid

import cli.commands.host_shared.ovs_util as ovs_util

from cli.commands.cli_command_provider import CliCommandProvider


lg = nsx_logging.getLogger("cli.commands.host_kvm.logical_switch")

class HostGetLogicalSwitchSummary(CliCommandProvider):
    def __call__(self, cmd_list):
        res = []
        lp_count = {}
        lp_list = ovs_util.get_lport_list() # lport vni vni_status
        for lport in lp_list:
            arr = lport[1].split(':')
            id = (arr[0] == "VNI", arr[1])
            if id not in lp_count:
                lp_count[id] = 1
            else:
                lp_count[id] = lp_count[id] + 1
        ls_list = ovs_util.get_lswitch_list() # uuid vni
        for lswitch in ls_list:
            ls_uuid = lswitch[0]
            ls_id = (lswitch[1] == "VNI", lswitch[2])
            # ls_name may not be present during upgrade
            ls_name = ""
            if (len(lswitch) > 3):
                ls_name = lswitch[3]
            res.append({'uuid': ls_uuid, 'id': ls_id[1],
                        'is_vni': ls_id[0],
                        'num_ports': lp_count.get(ls_id, 0), 'name': ls_name})
        return "OK\n\n%s" % json.dumps(res)
